/********************************** (C) COPYRIGHT *******************************
* File Name          : main.c
* Author             : WCH
* Version            : V1.0.0
* Date               : 2021/06/06
* Description        : Main program body.
*********************************************************************************
* Copyright (c) 2021 Nanjing Qinheng Microelectronics Co., Ltd.
* Attention: This software (modified or not) and binary are used for 
* microcontroller manufactured by Nanjing Qinheng Microelectronics.
*******************************************************************************/

/*
 *@Note
 USART Print debugging routine:
 USART1_Tx(PA9).
 This example demonstrates using USART1(PA9) as a print debug port output.

*/

#include "debug.h"


/* Global typedef */

/* Global define */

/* Global Variable */

#define FREQ_SYS                40000000
#define MDELAYUS_LOOP_TICKS     4
#define __nop()                 __asm__ volatile("nop")
/*********************************************************************
 * @fn      mDelayuS
 *
 * @brief   uS ʱ
 *
 * @param   t       - ʱ
 *
 * @return  none
 */
void mDelayuS(uint16_t t)
{
    uint32_t i;

    i = t * (FREQ_SYS / 1000000 / MDELAYUS_LOOP_TICKS);

    do
    {
        __nop();
    } while(--i);
}

void LED_GPIO_Init(void)
{
    GPIO_InitTypeDef  GPIO_InitStructure={0};

    RCC_APB2PeriphClockCmd( RCC_APB2Periph_GPIOA, ENABLE);

    GPIO_InitStructure.GPIO_Pin = GPIO_Pin_1;
    GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;
    GPIO_Init(GPIOA, &GPIO_InitStructure);
}

/*********************************************************************
 * @fn      main
 *
 * @brief   Main program.
 *
 * @return  none
 */
int main(void)
{
	NVIC_PriorityGroupConfig(NVIC_PriorityGroup_2);
	SystemCoreClockUpdate();
	Delay_Init();
	USART_Printf_Init(115200);	
	printf("SystemClk:%d\r\n",SystemCoreClock);
	printf( "ChipID:%08x\r\n", DBGMCU_GetCHIPID() );
	printf("This is printf example\r\n");

	LED_GPIO_Init();

	while(1)
    {
	    GPIO_SetBits(GPIOA, GPIO_Pin_1);
	    mDelayuS(100);
	    GPIO_ResetBits(GPIOA, GPIO_Pin_1);
	    mDelayuS(100);
	}
}

